#! /usr/bin/env node
"use strict";

require("core-js/modules/es6.object.define-property");

require("core-js/modules/es6.object.define-properties");

require("core-js/modules/es6.object.freeze");

require("core-js/modules/es6.promise");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("core-js/modules/es6.regexp.replace");

require("regenerator-runtime/runtime");

var _path = _interopRequireDefault(require("path"));

var _chalk = _interopRequireDefault(require("chalk"));

var _npmWhich = _interopRequireDefault(require("npm-which"));

var _debug = _interopRequireDefault(require("debug"));

var _execa = _interopRequireDefault(require("execa"));

var _handleUnhandledRejection = _interopRequireDefault(require("@cat-org/utils/lib/handleUnhandledRejection"));

var _logger = _interopRequireWildcard(require("@cat-org/logger"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _templateObject3() {
  var data = _taggedTemplateLiteral(["Can not find {red lerna} in the project"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["Install {red flow} before using {green lerna-flow-typed-install}"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["Can not find {red flow version} in the project"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var debugLog = (0, _debug.default)('lerna-flow-typed-install:bin');
var logSettings = (0, _logger.findSettings)('log');
var _console = console,
    error = _console.error;
(0, _handleUnhandledRejection.default)();

logSettings.fail.after = function () {
  error();
  process.exit(1);
};

_asyncToGenerator(
/*#__PURE__*/
_regenerator.default.mark(function _callee() {
  var logger, _require, _require$devDependenc, flowVersion;

  return _regenerator.default.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          logger = (0, _logger.default)('@cat-org/lerna-flow-typed-install', logSettings);
          _context.prev = 1;
          _require = require(_path.default.resolve((0, _npmWhich.default)(process.cwd()).sync('lerna'), '../../../package.json')), _require$devDependenc = _require.devDependencies;
          _require$devDependenc = _require$devDependenc === void 0 ? {} : _require$devDependenc;
          flowVersion = _require$devDependenc['flow-bin'];
          if (!flowVersion) logger.fail((0, _chalk.default)(_templateObject()), (0, _chalk.default)(_templateObject2()));
          _context.next = 8;
          return _execa.default.shell("flow-typed install -f ".concat(flowVersion.replace(/\^/, ''), " ").concat(process.argv.slice(2).join(' ')), {
            stdio: 'inherit'
          });

        case 8:
          _context.next = 14;
          break;

        case 10:
          _context.prev = 10;
          _context.t0 = _context["catch"](1);
          debugLog(_context.t0);
          logger.fail((0, _chalk.default)(_templateObject3()));

        case 14:
        case "end":
          return _context.stop();
      }
    }
  }, _callee, this, [[1, 10]]);
}))();